/* Sistemas Integrados TECNISA

Nome: 9816_QPRTRGS_LOG_QPR_PARAMETROQPR.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   14/01/2016 - Jurandir Junio
*/

/* Tabela PARAMETROQPR.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              PARAMETROQPR, para verifio de erros */
IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_QPR_PARAMETROQPR' AND
                TYPE   = 'TR'                 AND
                U.UID  = O.UID                AND
                U.NAME = USER)

DROP TRIGGER LOG_QPR_PARAMETROQPR
GO


CREATE TRIGGER LOG_QPR_PARAMETROQPR
ON PARAMETROQPR
FOR UPDATE,INSERT, DELETE
AS
BEGIN

   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DESC         VARCHAR(500);
   DECLARE @V_ITPESQ       VARCHAR(80);
   DECLARE @V_NMOPERADOR   VARCHAR(40);
   DECLARE @V_IDCLIEATIV   VARCHAR(1);
   DECLARE @V_NRINCREST    VARCHAR(40);
   DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_TRIGGER         VARCHAR(1);

   DECLARE @V_CDFILIAL_OLD        VARCHAR(4);
   DECLARE @V_NRDIAMINQUA_OLD     VARCHAR(5);
   DECLARE @V_NRDIASVENANA_OLD    NUMERIC;
   DECLARE @V_IDRATEIACUSTO_OLD   VARCHAR(1);
   DECLARE @V_IDCONTROLOCAL_OLD   VARCHAR(1);
   DECLARE @V_CDALMOXARIFE_OLD    VARCHAR(6);
   DECLARE @V_CDLOCALESTOQ_OLD    VARCHAR(6);
   DECLARE @V_IDUTSEGLIBANA_OLD   VARCHAR(1);

   DECLARE @V_CDFILIAL_NEW        VARCHAR(4);
   DECLARE @V_NRDIAMINQUA_NEW     VARCHAR(5);
   DECLARE @V_NRDIASVENANA_NEW    NUMERIC;
   DECLARE @V_IDRATEIACUSTO_NEW   VARCHAR(1);
   DECLARE @V_IDCONTROLOCAL_NEW   VARCHAR(1);
   DECLARE @V_CDALMOXARIFE_NEW    VARCHAR(6);
   DECLARE @V_CDLOCALESTOQ_NEW    VARCHAR(6);
   DECLARE @V_IDUTSEGLIBANA_NEW   VARCHAR(1);
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDCLIEATIV = '';
   SET @V_NRINCREST  = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,

         CDFILIAL,
         NRDIAMINQUA,
         NRDIASVENANA,
         IDRATEIACUSTO,
         IDCONTROLOCAL,
         CDALMOXARIFE,
         CDLOCALESTOQ,
         IDUTSEGLIBANA,

         NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL

      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)
      UNION ALL

      SELECT
         'U' IDCOMANDO,

         DELETED.CDFILIAL,
         DELETED.NRDIAMINQUA,
         DELETED.NRDIASVENANA,
         DELETED.IDRATEIACUSTO,
         DELETED.IDCONTROLOCAL,
         DELETED.CDALMOXARIFE,
         DELETED.CDLOCALESTOQ,
         DELETED.IDUTSEGLIBANA,

         INSERTED.CDFILIAL,
         INSERTED.NRDIAMINQUA,
         INSERTED.NRDIASVENANA,
         INSERTED.IDRATEIACUSTO,
         INSERTED.IDCONTROLOCAL,
         INSERTED.CDALMOXARIFE,
         INSERTED.CDLOCALESTOQ,
         INSERTED.IDUTSEGLIBANA

      FROM
         DELETED,
         INSERTED
      WHERE
         INSERTED.CDFILIAL  = DELETED.CDFILIAL
      UNION ALL

      SELECT
        'I' IDCOMANDO,

         NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
         CDFILIAL,
         NRDIAMINQUA,
         NRDIASVENANA,
         IDRATEIACUSTO,
         IDCONTROLOCAL,
         CDALMOXARIFE,
         CDLOCALESTOQ,
         IDUTSEGLIBANA
     FROM
        INSERTED
     WHERE
        0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,

                @V_CDFILIAL_OLD       ,
                @V_NRDIAMINQUA_OLD    ,
                @V_NRDIASVENANA_OLD   ,
                @V_IDRATEIACUSTO_OLD  ,
                @V_IDCONTROLOCAL_OLD  ,
                @V_CDALMOXARIFE_OLD   ,
                @V_CDLOCALESTOQ_OLD   ,
                @V_IDUTSEGLIBANA_OLD  ,

                @V_CDFILIAL_NEW       ,
                @V_NRDIAMINQUA_NEW    ,
                @V_NRDIASVENANA_NEW   ,
                @V_IDRATEIACUSTO_NEW  ,
                @V_IDCONTROLOCAL_NEW  ,
                @V_CDALMOXARIFE_NEW   ,
                @V_CDLOCALESTOQ_NEW   ,
                @V_IDUTSEGLIBANA_NEW  ;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF @V_ID_TRIGGER = 'I' BEGIN

            IF @V_CDFILIAL_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CDFILIAL= ' + ISNULL(@V_CDFILIAL_NEW,'') + ' ';
            END;

            IF @V_NRDIAMINQUA_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'NRDIAMINQUA= ' + ISNULL(@V_NRDIAMINQUA_NEW,'') + ' ';
            END;

            IF @V_NRDIASVENANA_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'NRDIASVENANA= ' + ISNULL(@V_NRDIASVENANA_NEW,'') + ' ';
            END;

            IF @V_IDRATEIACUSTO_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'IDRATEIACUSTO= ' + ISNULL(@V_IDRATEIACUSTO_NEW,'') + ' ';
            END;

            IF @V_IDCONTROLOCAL_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'IDCONTROLOCAL= ' + ISNULL(@V_IDCONTROLOCAL_NEW,'') + ' ';
            END;

            IF @V_CDALMOXARIFE_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CDALMOXARIFE= ' + ISNULL(@V_CDALMOXARIFE_NEW,'') + ' ';
            END;

            IF @V_CDLOCALESTOQ_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CDLOCALESTOQ= ' + ISNULL(@V_CDLOCALESTOQ_NEW,'') + ' ';
            END;

            IF @V_IDUTSEGLIBANA_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'IDUTSEGLIBANA= ' + ISNULL(@V_IDUTSEGLIBANA_NEW,'') + ' ';
            END;

           SET @V_IDTIPOOPER = '1';
         END
         ELSE BEGIN
            IF @V_ID_TRIGGER = 'U' BEGIN

            IF (@V_CDFILIAL_OLD <> @V_CDFILIAL_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'CDFILIAL= ' + ISNULL(@V_CDFILIAL_NEW,'') + ' ';
            END;

            IF (@V_NRDIAMINQUA_OLD <> @V_NRDIAMINQUA_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'NRDIAMINQUA= ' + ISNULL(@V_NRDIAMINQUA_NEW,'') + ' ';
            END;

            IF (@V_NRDIASVENANA_OLD <> @V_NRDIASVENANA_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'NRDIASVENANA= ' + ISNULL(@V_NRDIASVENANA_NEW,'') + ' ';
            END;

            IF (@V_IDRATEIACUSTO_OLD <> @V_IDRATEIACUSTO_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'IDRATEIACUSTO= ' + ISNULL(@V_IDRATEIACUSTO_NEW,'') + ' ';
            END;

            IF (@V_IDCONTROLOCAL_OLD <> @V_IDCONTROLOCAL_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'IDCONTROLOCAL= ' + ISNULL(@V_IDCONTROLOCAL_NEW,'') + ' ';
            END;

            IF (@V_CDALMOXARIFE_NEW <> @V_CDALMOXARIFE_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'CDALMOXARIFE= ' + ISNULL(@V_CDALMOXARIFE_NEW,'') + ' ';
            END;

            IF (@V_CDLOCALESTOQ_OLD <> @V_CDLOCALESTOQ_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'CDLOCALESTOQ= ' + ISNULL(@V_CDLOCALESTOQ_NEW,'') + ' ';
            END;

            IF (@V_IDUTSEGLIBANA_OLD <> @V_IDUTSEGLIBANA_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'IDUTSEGLIBANA= ' + ISNULL(@V_IDUTSEGLIBANA_NEW,'') + ' ';
            END;

            SET @V_IDTIPOOPER = '2';

         END;

         IF @V_ID_TRIGGER = 'D'  BEGIN

            IF @V_CDFILIAL_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CDFILIAL= ' + ISNULL(@V_CDFILIAL_OLD,'') + ' ';
            END;

            IF @V_NRDIAMINQUA_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'NRDIAMINQUA= ' + ISNULL(@V_NRDIAMINQUA_OLD,'') + ' ';
            END;

            IF @V_NRDIASVENANA_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'NRDIASVENANA= ' + ISNULL(@V_NRDIASVENANA_OLD,'') + ' ';
            END;

            IF @V_IDRATEIACUSTO_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'IDRATEIACUSTO= ' + ISNULL(@V_IDRATEIACUSTO_OLD,'') + ' ';
            END;

            IF @V_IDCONTROLOCAL_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'IDCONTROLOCAL= ' + ISNULL(@V_IDCONTROLOCAL_OLD,'') + ' ';
            END;

            IF @V_CDALMOXARIFE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CDALMOXARIFE= ' + ISNULL(@V_CDALMOXARIFE_OLD,'') + ' ';
            END;

            IF @V_CDLOCALESTOQ_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CDLOCALESTOQ= ' + ISNULL(@V_CDLOCALESTOQ_OLD,'') + ' ';
            END;

            IF @V_IDUTSEGLIBANA_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'IDUTSEGLIBANA= ' + ISNULL(@V_IDUTSEGLIBANA_OLD,'') + ' ';
            END;



            SET @V_IDTIPOOPER = '3';
         END;
      END;

     IF NOT (@V_DESC IS NULL) BEGIN

        INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                               IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                               DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                               DSMETUSUOPER, CDORESPOPER)
                    VALUES   ('PARAMETROQPR', GETDATE() ,    ISNULL(@V_NMOPERADOR,' '),
                               @V_IDTIPOOPER,   @V_DESC, @V_ITPESQ,
                               @V_DSSERVERRDM, @V_DSREMOTEADDR,  @V_DSREMOTEHOST,
                               @V_DSSERVMETHOD,   @V_DSREMOTEOPER);
     END;

   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,

    		       @V_CDFILIAL_OLD        ,
                @V_NRDIAMINQUA_OLD     ,
                @V_NRDIASVENANA_OLD    ,
                @V_IDRATEIACUSTO_OLD   ,
                @V_IDCONTROLOCAL_OLD   ,
                @V_CDALMOXARIFE_OLD    ,
                @V_CDLOCALESTOQ_OLD    ,
                @V_IDUTSEGLIBANA_OLD   ,

                @V_CDFILIAL_NEW        ,
                @V_NRDIAMINQUA_NEW     ,
                @V_NRDIASVENANA_NEW    ,
                @V_IDRATEIACUSTO_NEW   ,
                @V_IDCONTROLOCAL_NEW   ,
                @V_CDALMOXARIFE_NEW    ,
                @V_CDLOCALESTOQ_NEW    ,
                @V_IDUTSEGLIBANA_NEW   ;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_QPR_PARAMETROQPR','5.85.xxx';
GO
